#include <cstdio>
#include <iostream>
#include <cstring>
#include <cmath>
#include <string>
#include <algorithm>
#include <vector>
#include <queue>
#include <map>

using namespace std;

int n, m;
const int INF = 1 << 31 - 1;

struct node{
    int to;
    int next;
    int weight;
}e[201];

int w[210];
int lastshow[210];
int dp[210][510]; //dp[x][i]xm
bool inqueue[2010];
queue<int>q;
long long d[210];
int cnt = -1;
int used[210];
int path[210];

void insert(int a, int b, int w){
    e[++cnt].to = b;         //0
    e[cnt].weight = w;
    e[cnt].next = lastshow[a];
    lastshow[a] = cnt;
}

bool spfa(){
    q.push(1);
    int qq[2005];
    while(!q.empty()){
        int x = q.front();
        q.pop();
        inqueue[x] = false;
        int id = lastshow[x];
        while(id != -1){
            if(d[x] < INF && d[e[id].to] > e[id].weight + d[x]){
                d[e[id].to] = e[id].weight + d[x];
                path[e[id].to] = x;           //
                qq[e[id].to] = id;            //
                if(!inqueue[e[id].to]){
                    inqueue[e[id].to] = true;
                    q.push(e[id].to);
                }
            }
            id = e[id].next;
        }
    }
    int i;
    for(i = n; path[i] != -1; i = path[i]){   //path[i]!=-1i!=-10
        e[qq[i]].weight = 0;
    }
    return false;
}

void init(){
    int i;
    memset(used, 0, sizeof(used));
    memset(path, -1, sizeof(path));
    memset(dp, 0, sizeof(dp));
    memset(lastshow, -1, sizeof(lastshow));
    for(i = 1; i <= n; i ++){
        inqueue[i] = false;
    }
    for(i = 1; i <= n; ++ i)
        d[i]=INF;
    d[1]=0;
    cnt=-1;
    while(!q.empty()){
        q.pop();
    }
}

void dfs(int x){//dp
    used[x] = 1;
    for(int k = lastshow[x]; k!= -1; k = e[k].next){
        int y = e[k].to;
        if(used[y])
            continue;
        dfs(y); //
        int tmp = e[k].weight * 2;
        for(int i = m; i >= tmp; i --){
            for(int j = i - tmp; j >= 0; j --){
                dp[x][i] = max(dp[x][i], dp[x][j] + dp[y][i - tmp - j]);
            }
        }
    }
    for(int i = 0; i <= m; i ++){
        dp[x][i] += w[x];//x
    }
}

int main(){
    int i, j, k;
    while(~scanf("%d %d", &n, &m)){
        int a, b, c;
        init();
        for(i = 0; i < n - 1; i ++){
            scanf("%d %d %d", &a, &b, &c);
            insert(a, b, c);
            insert(b, a, c);
        }
        for(i = 1; i <= n; i ++){
            scanf("%d", &w[i]);
        }
        spfa();      //
        //cout << d[n] << endl;
        if(d[n] > m){
            printf("Human beings die in pursuit of wealth, and birds die in pursuit of food!\n");
        }
        else{
            m -= d[n]; //
            dfs(1); 
            printf("%d\n", dp[1][m]);
        }
    }
    return 0;
}